summaryrefslogtreecommitdiff
path: root/tests/chgrp/recurse
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chgrp/recurse')
-rwxr-xr-xtests/chgrp/recurse73
1 files changed, 73 insertions, 0 deletions
diff --git a/tests/chgrp/recurse b/tests/chgrp/recurse
new file mode 100755
index 0000000..871388c
--- /dev/null
+++ b/tests/chgrp/recurse
@@ -0,0 +1,73 @@
+#!/bin/sh
+# ad-hoc tests of chgrp with -R and -H or -L and symlinks
+
+# Copyright (C) 2000, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chgrp --version
+fi
+
+. $srcdir/../group-names
+
+pwd=`pwd`
+tmp=recurse.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework' 1>&2
+ (exit 1); exit 1
+fi
+
+set _ $groups; shift
+g1=$1
+g2=$2
+
+fail=0
+
+# chgrp -R should not traverse a symlink to a directory.
+mkdir d e
+touch d/dd e/ee
+ln -s ../e d/s
+chgrp -R $g1 e/ee || fail=1
+# This should not should change the group of e/ee
+chgrp -R $g2 d
+set _ `ls -ln e/ee`; g=$5; test "$g" = $g1 || fail=1
+# This must change the group of e/ee, since -L makes
+# chgrp traverse the symlink from d/s into e.
+chgrp -L -R $g2 d
+set _ `ls -ln e/ee`; g=$5; test "$g" = $g2 || fail=1
+
+# This must *not* change the group of e/ee
+chgrp -H -R $g1 d
+set _ `ls -ln e/ee`; g=$5; test "$g" = $g2 || fail=1
+
+ln -s d link
+
+# This shouldn't change the group of e/ee either.
+chgrp -H -R $g1 link || fail=1
+set _ `ls -ln e/ee`; g=$5; test "$g" = $g2 || fail=1
+# But it *should* change d/dd.
+set _ `ls -ln d/dd`; g=$5; test "$g" = $g1 || fail=1
+
+(exit $fail); exit $fail